// TestB25Dlg.cpp : t@C
//

#include "stdafx.h"
#include "TestB25.h"
#include "TestB25Dlg.h"

#include <typeinfo>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestB25Dlg _CAO


CTestB25Dlg::CTestB25Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestB25Dlg::IDD, pParent)
	, m_strTS(_T(""))
	, m_bEMM(FALSE)
	, m_bNULL(FALSE)
	, m_bDesc(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestB25Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_TS, m_strTS);
	DDX_Check(pDX, IDC_CHECK_EMM, m_bEMM);
	DDX_Check(pDX, IDC_CHECK_NULL, m_bNULL);
	DDX_Check(pDX, IDC_CHECK_DESC, m_bDesc);
}

BEGIN_MESSAGE_MAP(CTestB25Dlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_TS, &CTestB25Dlg::OnBnClickedButtonTs)
	ON_BN_CLICKED(IDC_BUTTON_START, &CTestB25Dlg::OnBnClickedButtonStart)
END_MESSAGE_MAP()


// CTestB25Dlg bZ[W nh

BOOL CTestB25Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CTestB25Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CTestB25Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestB25Dlg::OnBnClickedButtonTs()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);
	WCHAR strFile[MAX_PATH]=L"";
	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof (OPENFILENAME);
	ofn.hwndOwner = m_hWnd;
	ofn.lpstrFilter = 	TEXT("ts files (*.ts)\0*.ts\0")
					TEXT("All files (*.*)\0*.*\0\0");
	ofn.lpstrFile = strFile;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST;
	if (GetOpenFileName(&ofn) == 0) {
		return ;
	}
	m_strTS = strFile;
	UpdateData(FALSE);
}

void CTestB25Dlg::OnBnClickedButtonStart()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	m_pIB25 = NULL;
	m_pIB252 = NULL;
	m_hModuleB25 = NULL;



	if( LoadB25() == FALSE ){
		AfxMessageBox(L"B25Decoder.dll̃[hɎs܂");
		return ;
	}

	HANDLE hFile = CreateFile( m_strTS.GetBuffer(0), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if( hFile == INVALID_HANDLE_VALUE ){
		AfxMessageBox(L"TSt@CI[vł܂ł");
		return ;
	}

	DWORD dwH=0;
	DWORD dwL=0;
	_int64 i64ReadSize=0;
	_int64 i64FileSize=0;

	dwL=GetFileSize( hFile, &dwH );
	i64FileSize = ((_int64)dwH)<<32 | (_int64)dwL;

	BYTE bReadPack[188*128];
	DWORD dwRead = 0;
	while( i64ReadSize<i64FileSize){
		if( ReadFile(hFile, bReadPack, 188*128, &dwRead, NULL ) == FALSE ){
			AfxMessageBox(L"t@CReadł܂ł");
			break;
		}
		BYTE* pBuff=NULL;
		DWORD dwDst;
		m_pIB25->Decode(bReadPack,dwRead,&pBuff, &dwDst);
		
		i64ReadSize+=dwRead;
	}

	CloseHandle(hFile);

	if( m_pIB25 != NULL ){
		m_pIB25->Release();
		m_pIB25 = NULL;
		m_pIB252 = NULL;
	}
	if( m_hModuleB25 != NULL ){
		::FreeLibrary( m_hModuleB25 );
		m_hModuleB25=NULL;
	}

	UpdateData(FALSE);
}

BOOL CTestB25Dlg::LoadB25()
{
	if( m_hModuleB25 != NULL ){
		return TRUE;
	}
	WCHAR strExePath[512] = L"";
	GetModuleFileName(NULL, strExePath, 512);

	WCHAR szPath[_MAX_PATH];	// pX
	WCHAR szDrive[_MAX_DRIVE];
	WCHAR szDir[_MAX_DIR];
	WCHAR szFname[_MAX_FNAME];
	WCHAR szExt[_MAX_EXT];
	_tsplitpath_s( strExePath, szDrive, _MAX_DRIVE, szDir, _MAX_DIR, szFname, _MAX_FNAME, szExt, _MAX_EXT );
	_tmakepath_s(  szPath, _MAX_PATH, szDrive, szDir, NULL, NULL );

	CString strLoadPath = L"";
	strLoadPath.Format(L"%s\\B25Decoder.dll",szPath);

	BOOL bRet = TRUE;

	m_hModuleB25 = ::LoadLibrary(strLoadPath.GetBuffer(0));
	if( m_hModuleB25 == NULL ){
		return FALSE;
	}
	IB25Decoder* (*func)();
	func = (IB25Decoder* (*)())::GetProcAddress( m_hModuleB25 , "CreateB25Decoder");
	if( !func ){
		bRet = FALSE;
		goto ERR_END;
	}
	m_pIB25 = func();
	if( m_pIB25->Initialize() == FALSE ){
		m_pIB25->Release();
		m_pIB25 = NULL;
		bRet = FALSE;
	}else{
		try{
			m_pIB252 = dynamic_cast<IB25Decoder2 *>(m_pIB25);
			if( m_pIB252 != NULL ){
				if( m_bEMM == TRUE ){
					m_pIB252->EnableEmmProcess(true);
				}else{
					m_pIB252->EnableEmmProcess(false);
				}
				if( m_bNULL == TRUE ){
					m_pIB252->DiscardNullPacket(true);
				}else{
					m_pIB252->DiscardNullPacket(false);
				}
				if( m_bDesc == TRUE ){
					m_pIB252->DiscardScramblePacket(true);
				}else{
					m_pIB252->DiscardScramblePacket(false);
				}
			}else{
				m_pIB25->Release();
				m_pIB25 = NULL;
				bRet = FALSE;
			}
		}
		catch(std::__non_rtti_object){
			m_pIB252 = NULL;
		}
	}
ERR_END:
	if( bRet == FALSE ){
		::FreeLibrary( m_hModuleB25 );
		m_hModuleB25=NULL;
	}
	return bRet;
}
